CREATE SCHEMA Allgemeine_Objekte

-- Historie:
--
-- 31.05.2002 - 1.004 (1.007)
-- Erweiterung der Wertebereiche von Meter, Kilometer und Jahr
--
-- 12.09.2001 - 1.003 (1.004)
-- Typen Waehrung, Kubikzentimeter, Promille, Anzahl_einstellig ergnzt
--
-- 17.12.2000 - 1.002 (1.002)
-- Verlegung der oertlichen_Zuordnung und
-- der nicht_nach_ASB_klass_Strasse in das Straennetz
--
-- Verlegung der verwaltungstechn_Zuordnung in die Administration
--
-- 29.10.2000 - 1.001 (1.001)
-- passive Versionierung durch Integration der
-- Schemata allgemeine Geometrieobjekte und Grunderwerb
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE Wochentag (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(10) NOT NULL
)

INSERT INTO Wochentag VALUES (1,'Sonntag')
INSERT INTO Wochentag VALUES (2,'Montag')
INSERT INTO Wochentag VALUES (3,'Dienstag')
INSERT INTO Wochentag VALUES (4,'Mittwoch')
INSERT INTO Wochentag VALUES (5,'Donnerstag')
INSERT INTO Wochentag VALUES (6,'Freitag')
INSERT INTO Wochentag VALUES (7,'Samstag')

CREATE TABLE Startdatum (
   Startdatum_ID
      INTEGER NOT NULL PRIMARY KEY,
   Jahr
      INTEGER,
   Monat_im_Jahr
      INTEGER,
   Woche_im_Jahr
      INTEGER,
   Tag_im_Monat
      INTEGER,
   vorwaerts_oder_rueckwaerts
      INTEGER REFERENCES Logical_Types.Boolean,
   Woche_im_Monat
      INTEGER,
   Tag_in_der_Woche
      INTEGER,
   Stunde_am_Tag
      INTEGER,
   Minute_in_der_Stunde
      INTEGER,
   Sekunde_in_der_Minute
      INTEGER,
   CHECK ( ( Monat_im_Jahr IS NULL ) OR ( Woche_im_Jahr IS NULL ) )
)

CREATE TABLE Dauer (
   Dauer_ID
      INTEGER NOT NULL PRIMARY KEY,
   Jahre
      INTEGER,
   Monate
      INTEGER,
   Wochen
      INTEGER,
   Tage
      INTEGER,
   Stunden
      INTEGER,
   Minuten
      INTEGER,
   Sekunden
      INTEGER
)

CREATE TABLE Operator (
   Kennung
      CHAR(1) NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Operator VALUES ('+','Vereinigung')
INSERT INTO Operator VALUES ('*','Durchschnitt')
INSERT INTO Operator VALUES ('-','Differenz')

CREATE TABLE Zeitraum (
   Zeitraum_ID
      INTEGER NOT NULL PRIMARY KEY,
   hat_ersten_Zeitraum
      INTEGER REFERENCES Zeitraum,
   hat_zweiten_Zeitraum
      INTEGER REFERENCES Zeitraum,
   hat_Operator
      CHAR(1) REFERENCES Operator,
   hat_Startdatum
      INTEGER REFERENCES Startdatum,
   hat_Dauer
      INTEGER REFERENCES Dauer,
   FOREIGN KEY (Zeitraum_ID) REFERENCES Historisierung.historisches_Objekt,
   gueltig_von
      CHAR(10) NOT NULL, -- Datum
   CHECK ( gueltig_von LIKE '__.__.____' ),
   gueltig_bis
      CHAR(10) NOT NULL, -- Datum
   CHECK ( gueltig_bis LIKE '__.__.____' ),
   Art_Zeitraum
      INTEGER NOT NULL REFERENCES Art_Zeitraum
)

CREATE TABLE Art_Zeitraum (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(18) NOT NULL
)

INSERT INTO Art_Zeitraum VALUES (1,'einfacher_Zeitraum')
INSERT INTO Art_Zeitraum VALUES (2,'komplexer_Zeitraum')



CREATE SCHEMA Logical_Types


CREATE TABLE Boolean (
   Boolean_ID
      INTEGER NOT NULL PRIMARY KEY,
   Boolean
      VARCHAR (5)
) 

INSERT INTO Boolean VALUES ( 0 , 'FALSE' ) 
INSERT INTO Boolean VALUES ( 1 , 'TRUE' ) 

